      * Implementation des sockets
      * (C)2001 by Paul TOTH <tothpaul@free.fr>

     P CallServer      B
     D CallServer      PI            10I 0
     D  Name                           *   Value options(*string)
     D  Port                         10U 0 Value

     D Result          s             10I 0
     D pDWORD          s               *
     D DWORD           s             10U 0 Based(pDWORD)
     D Size            s             10I 0
     D INetAddr        s             10U 0

     C                   Eval      Result=socket(Internet:Stream:0)
     C     Result        CabEq     -1            Done

     C                   Eval      PHostEnt=GetHostByName(Name)
     C                   If        PHostEnt = *null
     C                   Eval      INetAddr = INet_Addr(Name)
     C                   Eval      pDWORD = %Addr(INetAddr)
     C                   Eval      saFamily = Internet
     C                   Else
     C                   Eval      pDWORD = HostAddr
     C                   Eval      saFamily = heType
     C                   EndIf

     C                   Eval      saPort   = Port
     C                   Eval      saAddr = DWORD
     C                   Eval      Size=%Size(SockAddr)
     C                   If        Connect(Result:PSockAddr:Size) < 0
     C                   Eval      Result=Close(Result)
     C                   Eval      Result=-1
     C                   EndIf

     C     Done          Tag
     C                   Return    Result
     P CallServer      E

     P CallIPServer    B
     D CallIPServer    PI            10I 0
     D  Addr                           *   Value options(*string)
     D  Port                         10U 0 Value

     D Result          s             10I 0
     D pDWORD          s               *
     D DWORD           s             10U 0 Based(pDWORD)
     D Size            s             10I 0
     D INetAddr        s             10U 0

     C                   Eval      Result=socket(Internet:Stream:0)
     C     Result        CabEq     -1            Done

     C                   Eval      INetAddr = INet_Addr(Addr)
     C                   Eval      pDWORD = %Addr(INetAddr)
     C                   Eval      saFamily = Internet

     C                   Eval      saPort   = Port
     C                   Eval      saAddr = DWORD
     C                   Eval      Size=%Size(SockAddr)
     C                   If        Connect(Result:PSockAddr:Size) < 0
     C                   Eval      Result=Close(Result)
     C                   Eval      Result=-1
     C                   EndIf

     C     Done          Tag
     C                   Return    Result
     P CallIPServer    E
      * ----------------------------------------------------------------------
     P StartServer     B
     D StartServer     PI            10I 0
     D  Port                         10I 0 Value
     D  MaxClient                    10I 0 Value

     D Result          s             10I 0
     D PSockAddr       s               *   inz(%addr(SockAddr))
     D SockAddr        ds
     D  saFamily                      5U 0
     D  saPort                        5U 0
     D  saAddr                       10U 0
     D  saZero                        8    inz(X'0000000000000000')
     D pError          s               *   inz(%addr(Error))
     D TError          ds
     D  eBytes                        4B 0 inz(%size(TError))
     D  eSize                         4B 0
     D  eExceptID                     7
     D  eReserved                     1
     D  eExceptDATA                  52

     D Size            s             10I 0
     D Error           s             10I 0
     D Bool            s             10I 0 inz(1)
     D PBool           s               *   inz(%ADDR(Bool))

     C                   Eval      Result=Socket(Internet:Stream:0)
     C     Result        CabEq     -1            Done
     C                   Eval      Size=%Size(Bool)
     C                   Eval      Error=SetSockOpt(Result:SOL_SOCKET:
     C                                              SO_REUSEADDR:PBool:Size)
     C     Error         CabNe     0             Abort
     C                   Eval      saFamily = Internet
     C                   Eval      saPort   = Port
     C                   Eval      saAddr   = 0
     C                   Eval      Size=%Size(SockAddr)
     C                   Eval      Error=Bind(Result:PSockAddr:Size:pError)
     C     Error         CabNe     0             Abort
     C                   Eval      Error=Listen(Result:MaxClient)
     C     Error         CabNe     0             Abort
     C                   Goto      Done
     C     Abort         Tag
     C                   Eval      Error=Close(Result)
     C                   Eval      Result=-1
     C     Done          Tag
     C                   Return    Result
     P StartServer     E
      * ----------------------------------------------------------------------
     P CloseSocket     B
     D CloseSocket     PI
     D  Socket                       10I 0
     D Error           s             10I 0
     C                   Eval      Error=ShutDown(Socket:0)
     C                   Eval      Error=Close(Socket)
     C                   Return
     P CloseSocket     E
      * ----------------------------------------------------------------------
     P WaitClient      B
     D WaitClient      PI            10I 0
     D  Socket                       10I 0

     D PSockAddr       s               *   inz(%addr(SockAddr))
     D SockAddr        ds
     D  saFamily                      5U 0
     D  saPort                        5U 0
     D  saAddr                       10U 0
     D  saZero                        8    inz(X'0000000000000000')
     D Size            s             10I 0

     C                   Eval      Size=%Size(SockAddr)
     C                   Return    Accept(Socket:pSockAddr:Size)
     P WaitClient      E
      * ----------------------------------------------------------------------
     P WriteLn         B

     D WriteLn         PI            10I 0
     D Socket                        10I 0
     D String                      1024    Value

     D Size            s              5  0
     D PChar           s               *

     C                   Eval      Size = %Len(%TrimR(String))

     C                   If        Size > 0
     C                   Call      'QDCXLATE'
     C                   Parm                    Size
     C                   Parm                    String
     C                   Parm      'Q297BF437'   Table            10
     C                   Parm      'QUSRSYS'     TableLib         10
     C                   EndIf

     C                   Eval      String = %TrimR(String) + CRLF
     C                   Eval      PChar=%addr(String)

     C                   Return    Send(Socket:PChar:Size+2:0)
     P                 E
      * ----------------------------------------------------------------------
     P ReadLn          B
     D ReadLn          PI            10I 0
     D  Socket                       10I 0
     D  String                     1024
     D Size            s             10I 0 inz(%Size(String))
     D PChar           s               *
     D Result          s             10I 0
     D Readed          s             10I 0
     D p               s              4  0

     C                   Eval      PChar  = %Addr(String)
     C                   Eval      String = ''
     C                   Eval      Result = 0

     C     Next          Tag
     C                   Eval      Readed=Recv(Socket:PChar:Size:0)
     C                   If        Readed>0
     C                   Eval      Result=Result+Readed
     C                   Eval      PChar=PChar+Readed
     C                   Eval      p=%Scan(CRLF:String)
     C     p             Cabeq     0             Next
     C                   Eval      Result=p-1
     C                   EndIf

     C                   If        Result>0
     C                   CALL      'QDCXLATE'
     C                   Parm      Result        BufLen            5 0
     C                   Parm                    String
     C                   Parm      'QEBCDIC'     Table            10
     C                   Parm      'QSYS'        TableLib         10
     C                   Eval      String=%subst(String:1:Result)
     C                   EndIf
     C                   Return    Result
     P ReadLn          E
