Library word400;

{
 FTP Download Library for AS/400
 Copyright (C) 2001  Paul Toth <tothpaul@free.fr>
 http://tothpaul.free.fr

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

}

uses
  windows,
  Messages,
  classes,
  sysutils,
  CrtSock,
  FtpSock;

{$ifdef debug}
procedure ShowMessage(s:string);
 begin
  MessageBox(0,PChar(s),'FTP/400',0)
 end;
{$endif}

function Download(Host,User,Password,Source,Target:PChar):integer; stdcall; export;
 var
  dout:TextFile;
  s:string;
 begin
 {$ifdef debug}ShowMessage('Login as '+User+' on '+Host);{$endif}
  Result:=FtpLogon(Host,User,Password);
  if Result>0 then begin
   try
   {$ifdef debug}ShowMessage('Open remote file '+Source);{$endif}
    Result:=FtpOpenRead(Source);
    if Result>0 then begin
     AssignCrtSock(Result,input,dout);
    {$ifdef debug}ShowMessage('Open local file '+Target);{$endif}
     AssignFile(output,Target);
     Rewrite(output);
     Readln(s);
     while s<>'' do begin
      WriteLn(s);
      ReadLn(s);
     end;
     CloseFile(output);
     Disconnect(Result);
     Result:=0;
    end;
   finally
    FtpLogoff;
   end;
  end;
 end;

exports
 Download;

begin
end.
